#include "sl811.h"

int		ep;		// Gh|Cgԍ
int		epsize;		// Gh|Cg̃TCY
int		addr;		// USBfoCXAhX
int		retry;		// gC
unsigned char	wr_cmd;		// MppPbg̃gO
unsigned char	rd_cmd;		// MppPbg̃gO

/**********************************/
/* pPbg̑M : USB_A𗘗p   */
/*                                */
/* data: Mf[^̃AhX     */
/* size: Mf[^̃TCY       */
/* flag: 0̏ꍇOUTpPbg     */
/*       1̏ꍇSETUPpPbg   */
/**********************************/
int write_data(char *data, int size, int flag) {
	int	remain, wsiz, timovr;
	char	pktstat;

	/* ̃f[^ */
	remain = size;

	/* USB FIFOobt@̐擪AhX̎w */
	SL811Write(SL11H_BUFADDRREG_A, SL11H_DATA_START);

	/* ΏۂƂȂUSBfoCXAhX̎w */
	SL811Write(SL11H_DEVADDRREG_A, addr);

	/* pPbg(OUT/SETUP)Gh|Cgԍ̎w */
	SL811Write(SL11H_PIDEPREG_A, (flag == 1) ? PID_SETUP : (PID_OUT | ep));

	do {
		/* 1̃pPbgőMf[^Zo */
		wsiz = (remain > epsize) ? epsize : remain;

		/* Mf[^ꍇ́AUSB FIFOobt@֓] */
		if(data != 0 && size > 0) {
			SL811BufWrite(SL11H_DATA_START, &data[size - remain], wsiz);
		}

		/* Mf[^̑傫Zbg */
		SL811Write(SL11H_BUFLNTHREG_A, wsiz);

		/* USBfoCXNAK̏ꍇAēxUSBf[^M */
		for(timovr = 0;timovr < 3;timovr++) {

			/* USB_AUSB FIFOobt@̓e𑗐M */
			SL811Write(SL11H_HOSTCTLREG_A, wr_cmd);

			/* USB_ȂM܂ő҂ */
			while(SL811Read(SL11H_INTSTATREG) & SL11H_INTMASK_XFERDONE_A == 0);
			/* 100}CNb̎ԑ҂ */
			waitus(100);

			/* USB_ÃpPbgMԂǂݍ */
			pktstat = SL811Read(SL11H_PKTSTATREG_A);

			/* USBfoCXACKԂĂ΁A[v𔲂 */
			if(pktstat & SL11H_STATMASK_ACK) break;

			/* gC̏ꍇA5~b̎ԑ҂ */
			waitus(5000);
		}
		/* USBf[^M̌ʂgCĂACKłȂꍇ́AG[I */
		if(!(pktstat & SL11H_STATMASK_ACK)) {
			return -1;
		}

		/* ς݂̃f[^ */
		remain -= wsiz;

		/* f[^pPbg̃gOs */
		wr_cmd = (wr_cmd == DATA0_WR) ? DATA1_WR : DATA0_WR;
	} while(remain > 0);	// cf[^ԁAJԂ

	/* USBf[^MTCYԂ */
	return size;
}

/**********************************/
/* pPbg̎M : USB_B𗘗p   */
/*                                */
/* data: Mf[^̃AhX     */
/* size: Mf[^̃TCY       */
/**********************************/
int read_data(char *data, int size) {
	char	pktstat, epsv;
	int	timovr, remain, rsiz, rcnt;
	int	maxretry, minretry;
	int	fifo;


	/* USB FIFOobt@̐擪AhX̏lݒ */
	fifo = SL11H_DATA_START;

	/* ̃f[^ */
	remain = size;

	/* USBfoCXNAK̂Ƃ̃gC */
	maxretry = retry;

	/* Z҂Ԃł̃gC */
	minretry = (maxretry <= 7) ? maxretry : maxretry / 3;

	/* ΏۂƂȂUSBfoCXAhX̎w */
	SL811Write(SL11H_DEVADDRREG_B, addr);

	/* pPbg(IN)ƃGh|Cgԍ̎w */
	SL811Write(SL11H_PIDEPREG_B, PID_IN | ep);

	do {
		/* 1̃pPbgőMf[^Zo */
		rsiz = (remain > epsize) ? epsize : remain;

		/* ݂USB FIFOobt@FFH𒴂ꍇAlݒ */
		if((fifo + rsiz) > 256) fifo = SL11H_DATA_START;

		/* ݂USB FIFOobt@̐擪AhX̎w */
		SL811Write(SL11H_BUFADDRREG_B, fifo);

		/* Mf[^̑傫Zbg */
		SL811Write(SL11H_BUFLNTHREG_B, rsiz);

		/* USBfoCXNAK̏ꍇAēxUSBf[^M */
		for(timovr = 0;timovr < maxretry;timovr++) {

			/* USB_BUSB FIFOobt@֓eM */
			SL811Write(SL11H_HOSTCTLREG_B, rd_cmd);

			/* 25}CNbA܂́A2~b̎ԑ҂ */
			waitus((timovr < minretry) ? 25 : 2000);

			/* USB_B̎M܂ő҂ */
			while(SL811Read(SL11H_INTSTATREG) & SL11H_INTMASK_XFERDONE_B == 0);

			/* USB_B̃pPbgMԂǂݍ */
			pktstat = SL811Read(SL11H_PKTSTATREG_B);

			/* USBfoCXSTALL̏ꍇ̓G[I */
			if(pktstat & SL11H_STATMASK_STALL) {
				return -1;
			}

			/* USBfoCXACKԂĂ΁A[v𔲂 */
			if(pktstat & SL11H_STATMASK_ACK) break;
		}

		/* USBf[^M̌ʂgCĂACKłȂꍇ́AG[I */
		if(timovr >= maxretry) {
			return -1;
		}

		/* ۂɎMf[^Zo */
		rcnt = rsiz - (int)SL811Read(SL11H_XFERCNTREG_B);

		/* Mf[^ꍇ́AUSB FIFOobt@] */
		if(pktstat & SL11H_STATMASK_ACK && data != 0 && size > 0) {
			SL811BufRead(fifo, &data[size - remain], rsiz);
		}

		/* ς݂̃f[^ */
		remain -= rcnt;

		/* f[^pPbg̃gOs */
		rd_cmd = (rd_cmd == DATA0_RD) ? DATA1_RD : DATA0_RD;

		/* ݂USB FIFOobt@̐擪AhX̍XV */
		fifo += rcnt;
	} while(remain > 0 && rcnt == rsiz);	// cf[^ԁAJԂ

	/* USBf[^MTCYԂ */
	return size - remain;
}
