#include <mes2.h>
#include "sl811.h"
#include "macro.h"
#include "usb.h"

extern volatile char	*sl811data, *sl811addr;
extern int		ep;		// Gh|Cgԍ
extern int		epsize;		// Gh|Cg̃TCY
extern int		addr;		// USBfoCXAhX
extern int		retry;		// gC
extern unsigned char	wr_cmd;		// MppPbg̃gO
extern unsigned char	rd_cmd;		// MppPbg̃gO
int	regTest(void);
int	USBReset(void);
int	write_data(char *data, int size, int flag);
int	read_data(char *data, int size);

#define MAX_CONFSIZE	192

void usb_init(void) {
	char	devdesc[8] = {TRANS_TO_HOST, 6, 0, 1, 0, 0, 64, 0};
	char	confdesc[8] = {TRANS_TO_HOST, 6, 0, 2, 0, 0, MAX_CONFSIZE, 0};
	char	setaddr[8] = {TRANS_TO_DEV, 5, 0, 0, 0, 0, 0, 0};
	char	setconf[8] = {TRANS_TO_DEV, 9, 1, 0, 0, 0, 0, 0};

	int	i, epnum;
	DevDesc	devinfo;
	CfgDesc *config;
	IntfDesc *interface;
	EPDesc	*endpoint;
	char	buffer[MAX_CONFSIZE];

	ep = 0;
	epsize = 8;
	retry = 20;

	/* foCXfBXNv^̉擾 */
	addr = 0;					// Address 0
	wr_cmd = DATA0_WR;
	write_data(devdesc, 8 ,1);			// SETUP
	rd_cmd = DATA1_RD;
	read_data((char*)&devinfo, 8);			// IN
	write_data(0, 0, 0);				// STATUS

	/* Gh|CgTCY̎擾 */
	epsize = devinfo.bMaxPacketSize0;

	/* foCXAhX1ɃZbg */
	setaddr[2] = 1;
	wr_cmd = DATA0_WR;
	write_data(setaddr, 8, 1);			// SETUP
	rd_cmd = DATA1_RD;
	read_data(0, 0);				// IN

	/* foCXfBXNv^̎擾 */
	addr = 1;					// Address 1
	wr_cmd = DATA0_WR;
	write_data(devdesc, 8, 1);			// SETUP
	rd_cmd = DATA1_RD;
	read_data((char*)&devinfo, sizeof(DevDesc));	// IN
	write_data(0, 0, 0);				// STATUS

	/* RtBO[VfBXNv^̎擾 */
	wr_cmd = DATA0_WR;
	write_data(confdesc, 8, 1);			// SETUP
	rd_cmd = DATA1_RD;
	read_data(buffer, MAX_CONFSIZE);		// IN
	write_data(0, 0, 0);				// STATUS

	int_enable();

	/* \̂̃|C^Zbg */
	config = (CfgDesc*)buffer;
	interface = (IntfDesc*)&buffer[config->bLength];
	endpoint = (EPDesc*)&buffer[config->bLength + interface->bLength];
	epnum = interface->bEndPoints;

	/* ̕\ */
	printf("Gh|Cg%d[oCg]\r", epsize);
	printf("x_ID      %04xh\r", le16toh(devinfo.idVendor) & 0xffff);
	printf("v_NgID  %04xh\r", le16toh(devinfo.idProduct) & 0xffff);
	printf("NX        %02xh\r", interface->iClass & 0xff);
	printf("TuNX    %02xh\r", interface->iSub & 0xff);
	printf("vgR    %02xh\r", interface->iProto & 0xff);
	for(i = 0;i < epnum;i++) {
		printf("****Gh|Cg(%d)****\r", endpoint[i].bEPAdd & 0x1f);
		printf((endpoint[i].bEPAdd & TRANS_TO_HOST) ? "device <- host\r" : "host <- device\r");
		switch(endpoint[i].bAttr & 0x03) {
		case 0: printf("Rg[]\r");break;
		case 1: printf("ACNiX]\r");break;
		case 2: printf("oN]\r");break;
		case 3: printf("C^vg]\r");break;
		}
	}
}

void waitus(int us) {
	volatile int	a;

	for(a = 0;a < us*2;a++);
}

int main() {
	int_disable();
	sl811data = (volatile char *)0x200002;
	sl811addr = (volatile char *)0x200000;
	regTest();
	USBReset();
	usb_init();
}
